<template>
  <a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
      <a-form-model ref="form" :model="model" :rules="validatorRules" slot="detail">
        <a-row>
          <a-col :span="12">
            <a-form-model-item label="员工姓名" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="employeeName">
              <a-input v-model="model.employeeName" placeholder="请输入员工姓名"></a-input>
            </a-form-model-item>
          </a-col>
          <a-col :span="12">
            <a-form-model-item label="联系电话" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="employeePhone">
              <a-input v-model="model.employeePhone" placeholder="请输入联系电话"></a-input>
            </a-form-model-item>
          </a-col>
          <a-col :span="12">
            <a-form-model-item label="员工职务" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="employeeDuties">
              <a-select style="width: 100%" v-model="model.employeeDuties" placeholder="请选择员工职务">
                <a-select-option v-for="item in dictOptions" :key="item.value" :value="item.value">{{item.label}}</a-select-option>
              </a-select>
            </a-form-model-item>
          </a-col>
          <a-col :span="12">
            <a-form-model-item label="状态" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="employeeStatus">
              <a-select style="width: 100%" v-model="model.employeeStatus" placeholder="请选择状态">
                <a-select-option value="1">在职</a-select-option>
                <a-select-option value="0">离职</a-select-option>
              </a-select>
            </a-form-model-item>
          </a-col>
          <a-col :span="12">
            <a-form-model-item label="性别" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="sex">
              <a-select style="width: 100%" v-model="model.sex" placeholder="请选择性别">
                <a-select-option :value="1">男</a-select-option>
                <a-select-option :value="2">女</a-select-option>
              </a-select>
            </a-form-model-item>
          </a-col>
        </a-row>

        <a-row>
          <a-col :span="24">
            <a-form-model-item label="员工头像" :labelCol="{ xs:{ span: 24 }, sm:{ span: 3 } }" :wrapperCol="wrapperCol" prop="employeeAvatar">
              <j-image-upload :isMultiple="false" text="点击上传" bizPath="scott/pic" v-model="model.employeeAvatar"></j-image-upload>
            <p style="line-height:1;margin:0">建议尺寸640*320，小于10M的JPG、PNG格式图片</p>
            </a-form-model-item>
          </a-col>
        </a-row>
      </a-form-model>
    </j-form-container>
  </a-spin>
</template>

<script>
  import Vue from 'vue'
  import { httpAction, getAction } from '@/api/manage'
  import { TENANT_ID } from "@/store/mutation-types"
  import {ajaxGetDictItems,getDictItemsFromCache} from '@/api/api'
  import { isMobile } from '@/utils/validate'

  export default {
    name: 'PropertyChargruleForm',
    props: {
      //表单禁用
      disabled: {
        type: Boolean,
        default: false,
        required: false
      }
    },
    data () {
      const validateToNextPhone = (rule, value, callback)=> {
        if (value && isMobile(value)) {
          callback();
        } else {
          callback('请输入正确的联系电话！');
        }
      }
      return {
        dictOptions: [],
        model:{
          employeeName: '',
          employeePhone: '',
          employeeDuties: '',
          employeeStatus: '1',
          sex: '',
          employeeAvatar: ''
         },
        labelCol: {
          xs: { span: 24 },
          sm: { span: 6 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        validatorRules: {
          employeeName: [{ required: true, message: '请输入员工姓名', trigger: 'blur' }],
          employeePhone: [
            { required: true, message: '请输入联系电话', trigger: 'blur' },
            { validator: validateToNextPhone }
          ],
          employeeDuties: [{ required: true, message: '请选择员工职务', trigger: 'change' }],
          sex: [{ required: true, message: '请选择员工性别', trigger: 'change' }]
        },
        url: {
          add: "/property-company/employee/companyEmployee/add",
          edit: "/property-company/employee/companyEmployee/edit",
          queryById: "/property-company/employee/companyEmployee/queryById"
        }
      }
    },
    computed: {
      formDisabled(){
        return this.disabled
      },
    },
    created () {
       //备份model原始值
      this.modelDefault = JSON.parse(JSON.stringify(this.model));
      this.initDictData()
    },
    methods: {
      initDictData() {
        //优先从缓存中读取字典配置
        if(getDictItemsFromCache('duties')){
          this.dictOptions = getDictItemsFromCache('duties');
          return
        }
        // //根据字典Code, 初始化字典数组
        ajaxGetDictItems('duties', null).then((res) => {
          if (res.success) {
            this.dictOptions = res.result;
          }
        })
      },
      ruleNumberInput(event) {
        let rateValue = event.target.value.replace(/[^\d]/g,"");//清除"数字"和"."和"-"以外的字符
        this.model['empowerDays'] = rateValue
      },
      add () {
        this.edit(this.modelDefault);
      },
      edit (record) {
        console.log(record)
        this.model = Object.assign({}, record);
        this.visible = true;
      },
      submitForm () {
        const that = this;
        // 触发表单验证
        this.$refs.form.validate(valid => {
          if (valid) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            httpAction(httpurl,{...this.model, communityCode: Vue.ls.get(TENANT_ID)},method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
            })
          }
         
        })
      }
    }
  }
</script>